#ifndef CONFIG_H
#define CONFIG_H
/*
 * file:    Config.h
 * purpose: abstract device
 */
// DAC is the output of the function generator
#define PORT_DAC            PORTB
#define DDR_DAC             DDRB

// 3 Pins for the encoder (user interface)
#define PORT_RIGHT_ENCODE   PIND
#define DDR_RIGHT_ENCODE    DDRD
#define PIN_RIGHT_ENCODE    PD1
#define PORT_LEFT_ENCODE    PIND
#define DDR_LEFT_ENCODE     DDRD
#define PIN_LEFT_ENCODE     PD2
#define PORT_PUSH_ENCODE    PIND
#define DDR_PUSH_ENCODE     DDRD
#define PIN_PUSH_ENCODE     PD3

// serial communication for display
#define PORT_CLOCK_COMM     PORTB
#define DDR_CLOCK_COMM      DDRB
#define PIN_CLOCK_COMM      PB7
#define PORT_DATA_COMM      PORTB
#define DDR_DATA_COMM       DDRB
#define PIN_DATA_COMM       PB6
#define PORT_SYNC_COMM      PORTD
#define DDR_SYNC_COMM       DDRD
#define PIN_SYNC_COMM       PD6      


// check button 4 times
#define BUTTON_SAMPLING     4             

// possible timer prescalings (only from system clock - external clocks cannot use the prescaler!)
#define PRESCALE_0          0                 
#define PRESCALE_1          1                 
#define PRESCALE_8          2                 
#define PRESCALE_64         3                 
#define PRESCALE_256        4                 
#define PRESCALE_1024       5                 


// use a prescale of 64, so on special crystals timer overflow counter match a second
#define TIMER_CLOCK         PRESCALE_64

// 8bit timer overflows per second 
// (only valid on special crystals i.e. 18,432 MHz or 22,1184 MHz)
//
// IMPORTANT: sync second value with the TIMER_CLOCK used
#define TPS                (F_CPU / 64 / 0xFF)     // in standard mode, overflow happens at top

#endif
