#include <inttypes.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "Config.h"
#define PLACE_GLOBALS_HERE
#include "DDS.h"
#include "Data.h"
#include "Counter.h"
#include "UI.h"
#include "SPI.h"
#include "Util.h"



/*
 * handling of user interface has low priority so happens here
 */
__attribute__ ((OS_main)) void main(void) {
   uint8_t      i=0;
   struct  sm * pUI;

   init(); 

   do {
      if (work.btPush > BUTTON_SAMPLING) {                 // push button of turning encoder switches level
         if (ui[work.level].type == EXEC_STATE) {
             setup();
             (*ui[work.level].pFunc)();

             work.level = 0;
         } else {
             work.level++;

             if (work.level > sizeof(ui))
                work.level = 0;
         }
         work.btPush = 0;
      }

      if (ui[work.level].type == NEXT_STATE) {             // entries with NEXT_STATE are silent entries
                                                           // just to have an option to display
         work.level = ui[work.level].pNext[0];             // skip to real entry
      }  
      work.display[0] = 0;
      work.display[1] = 0;
      work.display[2] = 0;
      work.display[3] = 0;
      work.display[4] = 0;
      work.display[5] = 0;

      pUI = ui + work.level;

      for (i=0; i < sizeof(pUI->pDisplay) && pUI->pDisplay[i]; i++) 
         work.display[i] = pUI->pDisplay[i];

      if (pUI->type == CHOICE_STATE) {
         struct sm * pChoice = ui + *pUI->pVar;

         for (i=0; i < sizeof(pChoice->pDisplay) && pChoice->pDisplay[i] && i < sizeof(work.display) -3; i++) 
            work.display[i+2] = pChoice->pDisplay[i];
      }
      updateDisplay();
   } while (1);
}

